<%@ CODEPAGE=65001 %>
<% Response.Charset="UTF-8" %>
<% Response.ContentType="text/xml" %>
<!-- #include file="FUNC/c_option.asp" -->
<!-- #include file="FUNC/c_system_lib.asp" -->
<!-- #include file="FUNC/c_function.asp" -->
<!-- #include file="FUNC/c_system_base.asp" -->
<!-- #include file="FUNC/c_xml_lib.asp" -->
<!-- #include file="FUNC/c_system_event.asp" -->

<%
Call System_Initialize()

If Not IsEmpty(Request.QueryString("cate")) Then
	ID=Request.QueryString("cate")
	Call CheckParameter(ID,"int",0)

	If ID=0 Then
	Response.write LoadFromFile(BlogPath & "/rss.xml","utf-8")
	Else
	Response.write  ExportRSSbyCate(ID)

	End IF
ElseIf Not IsEmpty(Request.QueryString("tagsID")) Then
	ID=Request.QueryString("tagsID")
	Call CheckParameter(ID,"int",0)

	If ID=0 Then
	Response.write LoadFromFile(BlogPath & "/rss.xml","utf-8")
	Else
	Response.write  ExportRSSbyTags(ID)
	End IF
ElseIf Not IsEmpty(Request.QueryString("map")) Then
	If IsEmpty(Application(ZC_BLOG_CLSID&"CACHE_SITEMAP")) Then
	Application.Lock
	Application(ZC_BLOG_CLSID&"CACHE_SITEMAP")=ExportSiteMap
	Application.UnLock
	Response.Write Application(ZC_BLOG_CLSID&"CACHE_SITEMAP")
	Else
	Response.Write Application(ZC_BLOG_CLSID&"CACHE_SITEMAP")
	End If
Else
	Response.write LoadFromFile(BlogPath & "/rss.xml","utf-8")
End If

Call System_Terminate()

If Err.Number<>0 then
 Call ShowError(0)
End If

Function ExportRSSbyTags(TagsID)

	Dim Rss2Export
	Dim objArticle

	Set Rss2Export = New TRss2Export

	With Rss2Export

	    Dim objRS,TagName

		.TimeZone=ZC_TIME_ZONE

		TagName=Tags(TagsID).Name

		.AddChannelAttribute "title",TransferHTML(ZC_BLOG_TITLE,"[html-format]") & " - " & TagName
		.AddChannelAttribute "link",TransferHTML(ZC_BLOG_HOST,"[html-format]")
		.AddChannelAttribute "description",TransferHTML(ZC_BLOG_SUBTITLE,"[html-format]") & " - " & TagName
		.AddChannelAttribute "generator","RainbowSoft Studio Z-Blog " & ZC_BLOG_VERSION
		.AddChannelAttribute "language",ZC_BLOG_LANGUAGE
		.AddChannelAttribute "copyright",TransferHTML(ZC_BLOG_COPYRIGHT,"[html-format]")
		.AddChannelAttribute "pubDate",Now

				Dim i

				Set objRS=objConn.Execute("SELECT [log_ID],[log_Tag],[log_CateID],[log_Title],[log_Intro],NULL,[log_Level],[log_AuthorID],[log_PostTime],[log_CommNums],[log_ViewNums],[log_TrackBackNums],[log_Url] FROM [blog_Article] WHERE ([log_ID]>0) AND ([log_Level]>2) AND ([log_Tag] LIKE '%{"&TagsID&"}%') ORDER BY [log_PostTime] DESC")

				If (Not objRS.bof) And (Not objRS.eof) Then
				For i=1 to ZC_RSS2_COUNT
					Set objArticle=New TArticle
					If objArticle.LoadInfoByArray(Array(objRS("log_ID"),objRS("log_Tag"),objRS("log_CateID"),objRS("log_Title"),objRS("log_Intro"),,objRS("log_Level"),objRS("log_AuthorID"),objRS("log_PostTime"),objRS("log_CommNums"),objRS("log_ViewNums"),objRS("log_TrackBackNums"),objRS("log_Url"))) Then
					.AddItem objArticle.HtmlTitle,Users(objArticle.AuthorID).Email & " (" & Users(objArticle.AuthorID).Name & ")",objArticle.HtmlUrl,objArticle.PostTime,objArticle.HtmlUrl,objArticle.HtmlIntro,Categorys(objArticle.CateID).HtmlName,objArticle.CommentUrl,objArticle.WfwComment,objArticle.WfwCommentRss,objArticle.TrackBackUrl
					End If
					objRS.MoveNext
					If objRS.eof Then Exit For
					Set objArticle=Nothing
				Next
				End If

	End With

	objRS.close
	Set objRS=Nothing
    ExportRSSbyTags=Rss2Export.xml
	Set Rss2Export = Nothing
End Function


Function ExportRSSbyCate(CateID)

	Dim Rss2Export
	Dim objArticle

	Set Rss2Export = New TRss2Export

	With Rss2Export

	    Dim objRS,CateName,CateIntro

		.TimeZone=ZC_TIME_ZONE

		Set objRS=objConn.Execute("SELECT [cate_ID],[cate_Name],[cate_Intro] from [blog_Category] where cate_ID="&CateID)
		If (Not objRS.bof) And (Not objRS.eof) Then
		CateName=TransferHTML(objRS("cate_Name"),"[html-format]")
		CateIntro=TransferHTML(objRS("cate_Intro"),"[html-format]")
		End If        
		objRS.close
	    Set objRS=Nothing

		.AddChannelAttribute "title",TransferHTML(ZC_BLOG_TITLE,"[html-format]") & " - " & CateName
		.AddChannelAttribute "link",TransferHTML(ZC_BLOG_HOST,"[html-format]")
		.AddChannelAttribute "description",TransferHTML(ZC_BLOG_SUBTITLE,"[html-format]") & " - " & CateIntro
		.AddChannelAttribute "generator","RainbowSoft Studio Z-Blog " & ZC_BLOG_VERSION
		.AddChannelAttribute "language",ZC_BLOG_LANGUAGE
		.AddChannelAttribute "copyright",TransferHTML(ZC_BLOG_COPYRIGHT,"[html-format]")
		.AddChannelAttribute "pubDate",Now

				Dim i

				Set objRS=objConn.Execute("SELECT [log_ID],[log_Tag],[log_CateID],[log_Title],[log_Intro],NULL,[log_Level],[log_AuthorID],[log_PostTime],[log_CommNums],[log_ViewNums],[log_TrackBackNums],[log_Url] FROM [blog_Article] WHERE ([log_ID]>0) AND ([log_Level]>2) AND ([log_CateID]="&CateID&") ORDER BY [log_PostTime] DESC")

				If (Not objRS.bof) And (Not objRS.eof) Then
				For i=1 to ZC_RSS2_COUNT
					Set objArticle=New TArticle
					If objArticle.LoadInfoByArray(Array(objRS("log_ID"),objRS("log_Tag"),objRS("log_CateID"),objRS("log_Title"),objRS("log_Intro"),,objRS("log_Level"),objRS("log_AuthorID"),objRS("log_PostTime"),objRS("log_CommNums"),objRS("log_ViewNums"),objRS("log_TrackBackNums"),objRS("log_Url"))) Then
					.AddItem objArticle.HtmlTitle,Users(objArticle.AuthorID).Email & " (" & Users(objArticle.AuthorID).Name & ")",objArticle.HtmlUrl,objArticle.PostTime,objArticle.HtmlUrl,objArticle.HtmlIntro,Categorys(objArticle.CateID).HtmlName,objArticle.CommentUrl,objArticle.WfwComment,objArticle.WfwCommentRss,objArticle.TrackBackUrl
					End If
					objRS.MoveNext
					If objRS.eof Then Exit For
					Set objArticle=Nothing
				Next
				End If

	End With

	objRS.close
	Set objRS=Nothing
    ExportRSSbyCate=Rss2Export.xml
	Set Rss2Export = Nothing
End Function

Function ExportSiteMap()

	Dim Map2Export

	Set Map2Export = New TSiteMap

	With Map2Export

		.TimeZone=ZC_TIME_ZONE

				Dim i,URL,AllNum

				AllNum=1

				Set objRS=objConn.Execute("SELECT COUNT([log_ID]) AS allarticle FROM [blog_Article]")
				If (Not objRS.bof) And (Not objRS.eof) Then
				AllNum=objRS("allarticle")
				End IF
				objRS.close
				Set objRS=Nothing
				

				Set objRS=objConn.Execute("SELECT [log_ID],[log_ID],[log_Level],[log_Url],[log_PostTime] FROM [blog_Article] WHERE ([log_ID]>0) AND ([log_Level]>2) ORDER BY [log_PostTime] DESC")

				If (Not objRS.bof) And (Not objRS.eof) Then
					For i=1 to AllNum
					
					URL=objRS("log_ID")
					If Trim(objRS("log_Url"))<>"" AND Not IsNull(objRS("log_Url")) Then URL=objRS("log_Url")
					
					
					.AddItem ZC_BLOG_HOST & ZC_STATIC_DIRECTORY & "/" & URL & "." & ZC_STATIC_TYPE,objRS("log_PostTime"),"weekly","0.8"

					objRS.MoveNext
					If objRS.eof Then Exit For

				Next
				End If

	End With

	objRS.close
	Set objRS=Nothing
    ExportSiteMap=Map2Export.xml
	Set Map2Export = Nothing

End Function

If Err.Number<>0 then
	Call ShowError(0)
End If
%>